/* Force_FGA5x00.cc */
/* Edited by Sanshiro E. on 6 October 1997. */
/* Last updated by Sanshiro E. on 27 December 1999. */


#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <sys/vme_types.h>
#include <sys/vme.h>
#include "vui.hh"
#include "Force_FGA5x00.hh"


static const char *VmeplusDeviceFileName[] = {
    /* this must be consistent with TVmeTarnsferMode */
    /* (declared in ParaVmeAccess.hh) */
    "/dev/vme16d16", "/dev/vme16d32",
    "/dev/vme24d16", "/dev/vme24d32", 
    "/dev/vme32d16", "/dev/vme32d32"
};

static const char *VmedmaDeviceFileName[] = {
    /* this must be consistent with TVmeTarnsferMode */
    /* (declared in ParaVmeAccess.hh) */
    "/dev/vmedma16d16", "/dev/vmedma16d32",
    "/dev/vmedma24d16", "/dev/vmedma24d32", 
    "/dev/vmedma32d16", "/dev/vmedma32d32"
};


TVmeController_Force_FGA5x00::TVmeController_Force_FGA5x00(void)
{
}

TVmeController_Force_FGA5x00::~TVmeController_Force_FGA5x00()
{
}

const char* TVmeController_Force_FGA5x00::DeviceFileName(TVmeTransferMode TransferMode)
{
    return VmeplusDeviceFileName[TransferMode];
}

const char* TVmeController_Force_FGA5x00::DmaDeviceFileName(TVmeTransferMode TransferMode)
{
    return VmedmaDeviceFileName[TransferMode];
}

void TVmeController_Force_FGA5x00::EnableInterruptNotification(TVmeAccessProperty* Property, int SignalId) throw(THardwareException)
{
    int DeviceDescriptor = Property->DeviceDescriptor;
    ioctl_irq_t InterruptDefinition;
    InterruptDefinition.prop = Property->InterruptNumber;
    InterruptDefinition.sig = SignalId;
  
    if (vui_intr_ena(DeviceDescriptor, &InterruptDefinition) != VUI_OK) {
	throw THardwareException(
	    "TVmeModule::EnableInterrupt(): ",
	    "interrupt enable fault.\n"
	    "  1) Doesn't another process use same interrupt?\n"
	    "  2) Is interrupt property(in /kernel/drv/vmeplus.conf) set correctly?"
        );
    }
}

void TVmeController_Force_FGA5x00::DisableInterruptNotification(TVmeAccessProperty* Property, int SignalId) throw(THardwareException)
{
    int DeviceDescriptor = Property->DeviceDescriptor;
    ioctl_irq_t InterruptDefinition;
    InterruptDefinition.prop = Property->InterruptNumber;
    InterruptDefinition.sig = SignalId;
  
    if (vui_intr_dis(DeviceDescriptor, &InterruptDefinition) != VUI_OK) {
	throw THardwareException(
	    "TVmeModule::EnableInterrupt(): ", 
	    "interrupt disable fault.\n"
	    "  1) Doesn't another process use same interrupt?\n"
	    "  2) Is interrupt property(in /kernel/drv/vmeplus.conf) set correctly?"
        );
    }
}
