/* RoomDeviceFactory.hh */
/* Edited by Sanshiro E. on 7 May 1999. */
/* Last updated by Sanshiro E. on 9 October 1999. */

#ifndef __RoomDeviceFactory_hh__
#define __RoomDeviceFactory_hh__


#include <iostream.h>
#include "RoomDefs.hh"
#include "RoomDeviceBase.hh"
#include "RoomModule.hh"
#include "RoomVmeAccess.hh"
#include "RoomCamacAccess.hh"
#include "RoomSoftwareDevice.hh"


class TDeviceFactory {
  public:
    static TDeviceFactory* GetInstance(void);
    virtual ~TDeviceFactory();
    virtual TVmeModule* CreateVmeModule(const string& Name) throw(THardwareException);
    virtual TCamacModule* CreateCamacModule(const string& Name) throw(THardwareException);
    virtual TSoftwareModule* CreateSoftwareModule(const string& Name) throw(THardwareException);
    virtual TVmeCrate* CreateVmeCrate(const string& Name = "") throw(THardwareException);
    virtual TCamacCrate* CreateCamacCrate(const string& Name = "") throw(THardwareException);
    virtual TVmeController* CreateVmeController(const string& Name = "") throw(THardwareException);
    virtual TCamacController* CreateCamacController(const string& Name = "") throw(THardwareException);
  protected:
    TDeviceFactory(void);
    string ReducedNameOf(string Name) const;
  protected:
    static TDeviceFactory* _Instance;
};


#endif
