/* intrtest.cc */
/* Edited by Sanshiro E. on 11 October 1997. */


#include <iostream.h>
#include <signal.h>
#include "RoomVmeAccess.hh"
#include "RoomDeviceFactory.hh"
#include "VmeModules.hh"


int main(void)
{
    TDeviceFactory* DeviceFactory = TDeviceFactory::GetInstance();

    TVmeController* VmeController = DeviceFactory->CreateVmeController();
    TVmeCrate* VmeCrate = new TVmeCrate();
    TVmeModule* IORegister = new TVmeIORegister_Rinei_RPV130();

    VmeCrate->InstallController(VmeController);
    VmeCrate->Install(IORegister, 0x8000, 3, 0xfff0);
    IORegister->Initialize();

    IORegister->EnableInterrupt(SIGPOLL);

    char buffer[64];
    cout << "Press <ENTER> to exit." << flush;
    cin >> buffer;

    IORegister->DisableInterrupt();

    delete IORegister;
    delete VmeCrate;
    delete VmeController;

    return 0;
}
